/*C**************************************************************************
* $RCSfile: can_protocol.c,v $
*----------------------------------------------------------------------------
* Copyright (c) 2003 Atmel.
*----------------------------------------------------------------------------
* J:			$Name: can11-bl-uart-can-0_0_8 $
* :			$Revision: 1.11 $
* FILE_CVSID:	$Id: can_protocol.c,v 1.11 2003/10/29 10:15:31 jberthy Exp $
*----------------------------------------------------------------------------
* ړI:
* ̧قCAN ISPK̊Ǘ܂݂܂B
*****************************************************************************/

/*_____ ݸٰ ____________________________________________________________*/
#include "config.h"
#include "lib_mcu/can/can_lib.h"
#include "lib_mcu/can/can_autobaud.h"
#include "can_protocol.h"
#include "lib_isp/interface.h"

/*_____ S _______________________________________________________________*/

/*_____ Ǐ֐錾 _______________________________________________________*/

/*_____ Ǐ _______________________________________________________________*/

/*_____ S֐ ___________________________________________________________*/
Uchar can_ctrl;
Uchar can_tx[NB_DATA_MAX];

can_data_t can_data;
can_msg_t can_msg;

Uchar f_timing_ok;
Uchar f_communication_open;
Uchar f_frame_to_send;
Uchar f_start_from_appli;

/*_____ Ǐ֐ ___________________________________________________________*/
void send_error_security (void);
Uchar can_write_data(void);
void can_display_data(void);
void can_init_write_data(void);
void can_init_display_data(void);

Uchar can_start_appli_ready;
Uchar start_appli_type;

Uint32  nb_byte_to_write;
Uint32  nb_byte_to_read;
Uchar   pt_buffer;
Uint16 	offset_id_copy;
Uchar 	nnb_copy, eb_copy;

/*F**************************************************************************
* O: can_init_from_appli
*----------------------------------------------------------------------------
* Ұ:
* ߂l: Ȃ
*----------------------------------------------------------------------------
* ړI:
*----------------------------------------------------------------------------
* :
*----------------------------------------------------------------------------
* :
*----------------------------------------------------------------------------
* Kv:
*****************************************************************************/
void can_init_from_appli(void)
{
  f_start_from_appli = 1;

  offset_id_copy = (CRIS<< 4);
	if (offset_id_copy > MAX_OFFSET_ID)
	{
	  offset_id_copy = 0;
	}
	nnb_copy = NNB;
  eb_copy  = EB;

  CAN_CONTROLLER_RESET;
  RazAllMailbox();

  // MƂ0`Ԑݒ
  can_rx_filt.std = (offset_id_copy);
  can_rx_msk.std  = 0x3F0;
  conf_rx         = CONF_NOIDE|CONF_NOBUFFER;	// Wڰт̒ʗ̎M
  CAN_SET_CHANNEL(CHANNEL_0);
  ConfChannel_Rx();

}

/*F**************************************************************************
* O: can_init_from_reset
*----------------------------------------------------------------------------
* Ұ:
* ߂l: Ȃ
*----------------------------------------------------------------------------
* ړI:
*----------------------------------------------------------------------------
* :
*----------------------------------------------------------------------------
* :
*----------------------------------------------------------------------------
* Kv:
*****************************************************************************/
void can_init_from_reset(void)
{
  f_start_from_appli = 0;

  offset_id_copy = (CRIS<< 4);
  if (offset_id_copy > MAX_OFFSET_ID)
  {
	offset_id_copy = 0;
  }
  nnb_copy = NNB;
  eb_copy = EB;

  CAN_CONTROLLER_RESET;
  RazAllMailbox();
  // MƂ0`Ԑݒ
  can_rx_filt.std = (offset_id_copy);
  can_rx_msk.std  = 0x3F0;
  conf_rx         = CONF_NOIDE|CONF_NOBUFFER;	// Wڰт̒ʗ̎M
  CAN_SET_CHANNEL(CHANNEL_0);
  ConfChannel_Rx();

  // ޯ ݸނ̓ǂݍ
  //----------------------
  if (eb_copy != 0xFF)
  {
	CANBT1 = BTC1;
	CANBT2 = BTC2;
	CANBT3 = BTC3;
	CAN_CONTROLLER_ENABLE;
	f_timing_ok = 0;
  }
  PORTD = 0xFF;
}

/*F**************************************************************************
* O: can_protocol_task_init
*----------------------------------------------------------------------------
* Ұ:
* ߂l: Ȃ
*----------------------------------------------------------------------------
* ړI:
* ̊֐CANCANԋ@\܂B
*----------------------------------------------------------------------------
* :
*----------------------------------------------------------------------------
* :
*----------------------------------------------------------------------------
* Kv:
*****************************************************************************/
void can_protocol_task_init (void)
{
  f_communication_open = 0;
  f_frame_to_send = 0;
  can_start_appli_ready = FALSE;

  pt_st_can_rx = &can_msg;
  can_msg.pt_donne = can_data;

  // VCAN`Ԑݒ
  //---------------------------------------------------------------------
  can_msg.id.std = 0x00;

  if (!f_start_from_appli)
  {
#ifndef DEBUG_BYPASSAUTOBAUD
	if  ((eb_copy ==0xFF)||
		((eb_copy!= 0xFF)&&((CANBT1==0xFF) ||(CANBT2 == 0xFF)||(CANBT3 == 0xFF))))
	{
	  ASM_CAN_AUTOBAUD();
	  CAN_AUTOBAUD_DISABLE;
	  f_timing_ok = 1;
	}
#else
	CANBT1 = 0x06;
	CANBT2 = 0x0C;
	CANBT3 = 0x5A;
	CAN_CONTROLLER_ENABLE;
#endif
  }
}

/*F**************************************************************************
* O: can_protocol_task
*----------------------------------------------------------------------------
* Ұ:
* ߂l: Ȃ
*----------------------------------------------------------------------------
* ړI:
* ̊֐CANKǗ܂B
*----------------------------------------------------------------------------
* :
*----------------------------------------------------------------------------
* :
*----------------------------------------------------------------------------
* Kv:
*****************************************************************************/
void can_protocol_task (void)
{
  Union32 union32;
  static bit restore_default_memspace;

  if (can_start_appli_ready)
  {
	can_start_appli_ready = FALSE;
	if (!isp_reset(start_appli_type))		/* ی !*/;
  }
  if (restore_default_memspace)
  {
	restore_default_memspace=FALSE;
	isp_select_memory(MEM_DEFAULT);
  }

/************** ُǗ ****************************/
/****************************************************/
  if((CANREC)&&(!f_timing_ok))
  {
	f_timing_ok = 1;
	ASM_CAN_AUTOBAUD();
	CAN_AUTOBAUD_DISABLE;					/* 擮`Ԃ̏I */
  }

/************** MǗ ****************************/
/****************************************************/
  CAN_SET_CHANNEL(CHANNEL_0);

  if (MOB_STATUS)
  {
	if (CAN_MSG_RECEIVED)					// үގMȂA
	{
	  ReadCanMsg(CHANNEL_RX_ENABLE);
	  f_timing_ok = 1;

	  switch ((can_msg.id.std - offset_id_copy))
	  {
		case CAN_ID_CHANGE_BASE_ADDR:
		{
		  if (f_communication_open)
		  {
			send_error_security();
			if (can_data[0]&0x02)
			{
			  isp_select_memory(can_data[1]);
			}
			if (can_data[0]&0x01)
			{
			  isp_select_page(can_data[2]);
			}
		  }
		  break;
		}

		case CAN_ID_PROG_START:
		{
		  if (f_communication_open)
		  {
			f_frame_to_send = 1;
			can_ctrl = 0x00;
			can_init_write_data();
			if (can_data[0]==0x80)			// I؂
			{
//------------ K̊Jn
			  #ifndef USE_RCS_CAN_PROTOCOL
			  label_isp_erase:
			  #endif // USE_RCS_CAN_PROTOCOL
//------------ K̏I
			  if(!isp_erase(can_data[1]<<8 | can_data[2]))
			  {
				send_error_security();
			  }
			  else
			  {
				can_ctrl = 0x01;
				can_tx[0] = 0x00;
			  }
			}
//---------- K̊Jn
			#ifndef USE_RCS_CAN_PROTOCOL
			else if (can_data[0]==1)		// EEPROM
			{
			  isp_select_memory(MEM_EEPROM);
			}
			#endif // USE_RCS_CAN_PROTOCOL
//---------- K̏I
		  } // end of "if (f_communication_open)"
		  break;
		}

		case CAN_ID_PROG_DATA:
		{
		  if (f_communication_open)
		  {
			f_frame_to_send = 1;
			can_ctrl = 0x01;
			can_tx[0] = can_write_data();
			if (can_tx[0] == COMMAND_SECURITY)
			{
			  send_error_security();
			}
		  }
		  break;
		}

		case CAN_ID_DISPLAY_DATA:
		{
		  if (f_communication_open)
		  {
			if (can_data[0] == 0x00)
			{
			  can_init_display_data();
			  can_display_data();
			}
			else if (can_data[0] == 0x80)
			{
			  can_init_display_data();
			  union32.dw = isp_blank_check(address,end_address);
			  if (MSB0(union32))			// 󔒌s
			  {
				*(Uint16*)&can_tx[0] = htons(union32.w[0]);
				can_ctrl = 0x02;
			  }
			  else
			  {
				can_ctrl = 0x00;
			  }
			  f_frame_to_send = 1;
			}
//---------- K̊Jn
			#ifndef USE_RCS_CAN_PROTOCOL
			else if (can_data[0] == 0x01)
			{
			  isp_select_memory(MEM_FLASH);
			  can_init_display_data();
			  union32.dw = isp_blank_check(address,end_address);
			  if (MSB0(union32))			// 󔒌s
			  {
				*(Uint16*)&can_tx[0] = htons(union32.w[0]);
				can_ctrl = 0x02;
			  }
			  else
			  {
				can_ctrl = 0x00;
			  }
			  f_frame_to_send = 1;
			}
			else if (can_data[0] == 0x02)
			{
			  restore_default_memspace=TRUE;
			  isp_select_memory(MEM_EEPROM);
			  can_init_display_data();
			  can_display_data();
			}
			#endif // USE_RCS_CAN_PROTOCOL
//---------- K̏I
		  } // end of "if (f_communication_open)"
		  break;
		}

		case CAN_ID_SELECT_NODE:
		{
		  if (((can_data[0] == nnb_copy) || (can_data[0] == 0xFF)) && (can_msg.ctrl == 0x01))
		  {
			if (f_communication_open ==0)
			{
			  f_communication_open = 1;
			  isp_select_memory(MEM_DEFAULT);
			  isp_select_page (PAGE_DEFAULT);
			}
			else
			{
			  f_communication_open = 0;
			}
			f_frame_to_send = 1;
			can_tx[0] = BOOT_VERSION;
			can_tx[1] = f_communication_open;
			can_ctrl  = 2;
		  }
		  break;
		}

//------ K̊Jn
		#ifndef USE_RCS_CAN_PROTOCOL

		case CAN_ID_READ_FUNCTION:
		{
		  if (f_communication_open)
		  {
			f_frame_to_send 	= 1;
			can_ctrl          = 1;
			if(can_data[0]==0x00)
			{
			  isp_select_memory(MEM_BOOT);
			  restore_default_memspace = TRUE;
			  can_tx[0] = isp_read (can_data[1]);
			}
			else if (can_data[0]==0x01)
			{
			  isp_select_memory(MEM_XAF);
			  restore_default_memspace = TRUE;
			  can_tx[0] = isp_read (can_data[1]);
			}
		  }
		  break;
		}

		case CAN_ID_WRITE_FUNCTION:
		{
		  if (f_communication_open)
		  {
			if (!*can_data)
			{
			  f_frame_to_send 	= 1;
			  can_ctrl = 0x01;
			  can_tx[0] = 0x00;
			  goto label_isp_erase;			// 
			}
			else if (*can_data==0x03)		// pJn
			{
			  address = ntohs(*(Uint16*)&can_data[2]);
			  start_appli_type = can_data[1];
			  can_start_appli_ready = TRUE;
			}
			else
			{								// `Ԑݒ菑
			  f_frame_to_send 	= 1;
			  can_ctrl = 1;
			  can_tx[0] = 0x00;				// OK
			  isp_select_memory(MEM_XAF);
			  restore_default_memspace = TRUE;
			  isp_write(can_data[1],can_data[2]);
			}
		  }
		  break;
		}
		#endif /* USE_RCS_CAN_PROTOCOL */
//------ K̏I

//------ VK̊Jn - JT.18.10.05
		#ifdef USE_RCS_CAN_PROTOCOL
		case CAN_ID_WRITE_FUNCTION:
		{
		  if (f_communication_open)
		  {
			if (*can_data==0x03)			// pJn
			{
			  address = can_data[2]<<8 | can_data[3];
			  start_appli_type = can_data[1];
			  can_start_appli_ready = TRUE;
			}
		  }
		  break;
		}
		#endif /* USE_RCS_CAN_PROTOCOL */
//------ VK̏I - JT.18.10.05

		default:
		{
		  break;
		}

	  } // end of "switch ((can_msg.id.std - offset_id_copy))"

//	  ENABLE_CHANNEL_RX;					/* ٌ`ԍĐݒ */
	}
  } // end of "if (MOB_STATUS)"

/************** MǗ ****************************/
/****************************************************/

  if (f_frame_to_send)
  {
	CAN_SET_CHANNEL(CHANNEL_1);
	while(GetMObStatus(CHANNEL_1)) ;		// ً(ȎMI)҂
	can_tx_id.std = can_msg.id.std;
	conf_tx       = can_ctrl;
	pt_candata_tx = can_tx;
	SendCanMsg();

	f_frame_to_send = 0;
  }
}

/*F****************************************************************************
* ֐: send_error_security
*----------------------------------------------------------------------------
* ֐쐬: BERTHY J.S.
* ֐쐬t:
*----------------------------------------------------------------------------
* ֐̖ړI:
* ֐̓: Ȃ
* ֐̏o: Ȃ
******************************************************************************/
void send_error_security (void)
{
  f_frame_to_send = 1;
  can_ctrl  = 0x01;
  can_msg.id.std = CAN_ID_ERROR_SECURITY + offset_id_copy;
  can_tx[0] = ERROR_SECURITY;

}

/*F**************************************************************************
* O: can_init_write_data
*----------------------------------------------------------------------------
* Ұ:
* ߂l: Ȃ
*----------------------------------------------------------------------------
* ړI:
*----------------------------------------------------------------------------
* :
*----------------------------------------------------------------------------
* :
*----------------------------------------------------------------------------
* Kv:
*****************************************************************************/
void can_init_write_data(void)
{
  address     = can_data[1]<<8 | can_data[2];
  end_address = can_data[3]<<8 | can_data[4];
  nb_byte_to_write = (Uint32)(end_address - address)+1 ;
  pt_buffer = 0;
}

/*F**************************************************************************
* O: can_init_display_data
*----------------------------------------------------------------------------
* Ұ:
* ߂l: Ȃ
*----------------------------------------------------------------------------
* ړI:
*----------------------------------------------------------------------------
* :
*----------------------------------------------------------------------------
* :
*----------------------------------------------------------------------------
* Kv:
*****************************************************************************/
void can_init_display_data(void)
{
  address     = can_data[1]<<8 | can_data[2];
  end_address = can_data[3]<<8 | can_data[4];
  nb_byte_to_read = (end_address - address)+1 ;
}

/*F**************************************************************************
* O: can_write_data
*----------------------------------------------------------------------------
* Ұ:
* ߂l: Ȃ
*----------------------------------------------------------------------------
* ړI:
*----------------------------------------------------------------------------
* :
*----------------------------------------------------------------------------
* :
*----------------------------------------------------------------------------
* Kv:
*****************************************************************************/
Uchar can_write_data(void)
{
  Uchar status;
  Uchar cpt_var;

  for (cpt_var=0; (cpt_var<can_msg.ctrl)&&(nb_byte_to_write); cpt_var++,pt_buffer++,nb_byte_to_write--)
  {
	buffer[pt_buffer] = can_data[cpt_var];
  }
  if ((pt_buffer<=(PROTOCOL_DATA-8))&&(nb_byte_to_write))
  {
	status = COMMAND_NEW_DATA;
  }
  else if ((pt_buffer>(PROTOCOL_DATA-8))&&(nb_byte_to_write))
  {
	if(isp_write_block(buffer, address, pt_buffer)==FALSE)
	{
	  status = COMMAND_SECURITY;
	}
	else
	{
	  status = COMMAND_NEW_DATA;
	  address += pt_buffer;
	  pt_buffer = 0;
	}
  }
  else		// if (nb_byte_to_write==0))
  {
	if(isp_write_block(buffer, address, pt_buffer)==FALSE)
	{
	  status = COMMAND_SECURITY;
	}
	else
	{
	  status = COMMAND_OK;
	}
  }
  return (status);
}

/*F**************************************************************************
* O: can_read_data
*----------------------------------------------------------------------------
* Ұ:
* ߂l: Ȃ
*----------------------------------------------------------------------------
* ړI:
*----------------------------------------------------------------------------
* :
*----------------------------------------------------------------------------
* :
*----------------------------------------------------------------------------
* Kv:
*****************************************************************************/
void can_display_data(void)
{
  Uchar cpt;
  Uint16 state;

  do
  {
	if (nb_byte_to_read >= NB_DATA_MAX)
	{
	  for (cpt=0; cpt<NB_DATA_MAX; cpt++, address++)
	  {
		state = isp_read (address);
		if (HIGH(state))
		{
		  send_error_security();
		  return;
		}
		can_tx[cpt] = LOW(state);
	  }
	  nb_byte_to_read -= 8;

	}
	else
	{
	  for (cpt=0; cpt<nb_byte_to_read; cpt++, address++)
	  {
		state = isp_read (address);
		if (HIGH(state))
		{
		  send_error_security();
		  return;
		}
		can_tx[cpt] = LOW(state);
	  }
	  nb_byte_to_read = 0;
	}
	CAN_SET_CHANNEL(CHANNEL_1);
	while(GetMObStatus(CHANNEL_1)) ;		// ً(ȎMI)҂
	can_tx_id.std = can_msg.id.std;
	conf_tx       = cpt;
	pt_candata_tx = can_tx;
	SendCanMsg();
  } while(nb_byte_to_read);
}
